function [means, bases]=subspace_bases(X, subspaceNumber, sampleLabels, energyLossThreshold, affine)

[ambientDimension, sampleNumber]=size(X);

means={};
for subspaceIndex=1:subspaceNumber
    groupX=X(:,sampleLabels==subspaceIndex);
    groupSize=size(groupX,2);
    if groupSize==0
        error(['No group can be empty!']);
    else
        if affine
            groupXMean=mean(groupX,2);
            groupX=groupX-groupXMean*ones(1,groupSize);
            means{subspaceIndex}=groupXMean;
        end;
        [U,S,V]=svds(groupX,min(ambientDimension,groupSize));
        sDiag=diag(S);
        uSize=subspace_dimension(sDiag,groupSize*energyLossThreshold);
%        distances=point_to_space_distance(groupX,U(:,1:uSize));
%        totalSE = sum(distances.*distances);         
        bases{subspaceIndex}(:,1:uSize)=U(:,1:uSize);
    end
end
